var CategoriesBoxList = React.createClass({
    getInitialState: function () {
        return {options: this.props.options, selectedCount: 0, opened: false};
    },
    handleChange: function (catId, currentItem) {
        let state = this.state.options.map(function (item) {
            item.selected = (item.id === catId ? !item.selected : item.selected);
            return item;
        });

        let selectedCount = state.reduce(function(sum, current) {
            return sum + (current.selected ? 1 : 0);
        }, 0);

        this.setState({options: state, selectedCount: selectedCount});

        function selectAllChildren(items, selValue = true) {
            items.forEach(function (item) {
                item.selected = selValue;

                if (item.children.length) {
                    selectAllChildren(item.children, selValue);
                }
            });
        }

        if (currentItem.children.length)
            selectAllChildren(currentItem.children, currentItem.selected);

        this.props.onChange();
    },
    handleToggle: function (item) {
        $('#cat-items' + item.id).slideToggle();

        item.opened = !(item.opened);
        this.setState({});

        //let item = this.state.options[itemId];
        //item.opened = !(item.opened);

        //this.setState({opened: !this.state.opened});
    },
    render: function () {
        var items = [];
        for (let itemId in this.state.options) {
            let item = this.state.options[itemId];
            let liClasses = [];

            if (item.children.length) {
                liClasses.push('_has-inner');
            }

            if (item.opened) {
                liClasses.push('_open');
            }

            liClasses = liClasses.join(' ');

            items.push(
                <li className={liClasses}>
                    <label>
                        <input type="checkbox" onChange={this.handleChange.bind(this, item.id, item)}
                                  checked={item.selected}/> 
                        <span></span> {item.name} 
                    </label>
                    <span className="arrow" categoryListId={item.id} onClick={this.handleToggle.bind(this, item)}></span>
                </li>
            );

            if (item.children.length) {
                items.push(<CategoriesBoxList 
                            opened={item.opened}
                            onChange={this.props.onChange}
                            options={item.children}
                            categoryId={item.id}
                            parentCategory={item} />);
            }
        }

        var listStyle = {};
        var elId = "cat-items" + this.props.categoryId;

        return (<ul id={elId} className="filter-list"
                    ref={(el) => { this.itemsList = el }}
                    style={listStyle}>
            {items}
        </ul>);
    }
});

var CategoriesBox = React.createClass({
    getInitialState: function () {
        return {options: this.props.options, opened: false, listElement: null};
    },
    valuesChanged: function () {
        let selectedIds = [];

        function getAllSelectedIds(items) {
            items.forEach(function(value) {
                if (value.selected && value.children.length == 0)
                    selectedIds.push(value.id);

                if (value.children.length) {
                    getAllSelectedIds(value.children);
                }
            });
        }

        getAllSelectedIds(this.state.options);

        this.props.onChange({
            selectedIds: selectedIds
        });
    },
    handleToggle: function () {
        $('#cat-items0').slideToggle();
        this.setState({options: this.state.options, opened: !this.state.opened});
    },
    render: function () {
        var titleClasses = ['filter-title', '_has-inner'];
        if (this.state.opened) {
            titleClasses.push('_open');
        }

        titleClasses = titleClasses.join(' ');

        return (
            <div className="filter-wrapper filter-prod">
                <div className={titleClasses} onClick={this.handleToggle.bind(this)}>
                    {this.props.title}
                    <span className="arrow"></span>
                </div>

                <CategoriesBoxList options={this.state.options}
                                   opened={this.state.opened}
                                   onChange={this.valuesChanged} 
                                   parentCategory={null} 
                                   categoryId="0" />
            </div>
        );
    }
});

function categoryBoxHandler(event) {
    window.queryFilter.categories = event.selectedIds;
    console.log('category')
    catalogfilterChanged();
}

let catSelectorElement = document.getElementById('product-category-selector');
if (catSelectorElement) {
    let title = catSelectorElement.getAttribute('title');
    ReactDOM.render(<CategoriesBox options={categories} title={title} onChange={categoryBoxHandler}/>, catSelectorElement);
}
